//
//  JpegǂݍDLL
//
//   2000/11/24 ˁ@P
//

library jpgr;

uses
  Windows,Classes,Graphics,jpeg;

function load(fn:PChar):PInteger;export;stdcall;
var
  jpg:TJpegImage;
  bmp:TBitmap;
  p,pp:PInteger;
  i:Integer;
begin

  jpg:=TJpegImage.Create;

  jpg.PixelFormat:=jf24bit;
  jpg.LoadFromFile(fn);

  bmp:=TBitmap.Create;

  bmp.HandleType:=bmDIB;
  bmp.PixelFormat:=pf32bit;
  bmp.Width:=jpg.Width;
  bmp.Height:=jpg.Height;
  bmp.Canvas.Draw(0,0,jpg);

  p:=PInteger(GlobalAlloc(GPTR,bmp.width*bmp.height*4+8));

  pp:=p;
  pp^:=jpg.width;
  inc(pp,1);
  pp^:=jpg.Height;
  inc(pp,1);

  for i:=0 to bmp.height-1 do
  begin
    CopyMemory(pp,bmp.scanLine[(bmp.height-1)-i],bmp.width*4);
    inc(pp,bmp.width);
  end;

  jpg.free;
  bmp.free;

  load:=p;

end;

function save(fn:PChar;lpBuf:PInteger;q:Integer):Integer;export;stdcall;
var
  jpg:TJpegImage;
  bmp:TBitmap;
  p:PInteger;
  width,height,i:Integer;
begin

  width:=lpBuf^;
  p:=lpBuf;
  inc(p,1);
  height:=p^;

  bmp:=TBitmap.Create;

  bmp.HandleType:=bmDIB;
  bmp.PixelFormat:=pf32bit;
  bmp.Width:=width;
  bmp.Height:=height;

  p:=PInteger(Integer(lpBuf)+8);

  for i:=0 to bmp.height-1 do
  begin
    CopyMemory(bmp.scanLine[(bmp.height-1)-i],p,bmp.width*4);
    inc(p,bmp.width);
  end;

  jpg:=TJpegImage.Create;
  jpg.PixelFormat:=jf24bit;
  jpg.GrayScale:=FALSE;
  jpg.CompressionQuality:=q;
  jpg.Assign(bmp);
  jpg.PixelFormat:=jf24bit;
  jpg.GrayScale:=FALSE;
  jpg.CompressionQuality:=q;
  jpg.SaveToFile(fn);

  jpg.free;
  bmp.free;

  save:=height;

end;

exports
  load name 'load',save name 'save';

begin
end.
